unit DnD_test_u;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ActiveX, ShlObj, ComObj, StdCtrls;

type
  TForm1 = class(TForm, IDropSource)
    Memo: TMemo;
    procedure MemoMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MemoMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    FDragStartPos: TPoint;
    function QueryContinueDrag(fEscapePressed: BOOL;
      grfKeyState: Longint): HResult; stdcall;
    function GiveFeedback(dwEffect: Longint): HResult; stdcall;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
function TForm1.QueryContinueDrag(fEscapePressed: BOOL;
  grfKeyState: Longint): HResult; stdcall;
begin
  if fEscapePressed or (grfKeyState and MK_RBUTTON = MK_RBUTTON) then
  begin
    Result := DRAGDROP_S_CANCEL
  end else if grfKeyState and MK_LBUTTON = 0 then
  begin
    Result := DRAGDROP_S_DROP
  end else
  begin
    Result := S_OK;
  end;
end;

function TForm1.GiveFeedback(dwEffect: Longint): HResult; stdcall;
begin
  Result := DRAGDROP_S_USEDEFAULTCURSORS;
end;


procedure TForm1.MemoMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbLeft then
    begin
      FDragStartPos.x := X;
      FDragStartPos.y := Y;
    end;
end;

procedure TForm1.MemoMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
const Threshold = 5;
var TempDir:array[0..64] of char;
    Malloc: IMalloc;
    Root: IShellFolder;
    FolderPidl: PItemIDList;
    Folder: IShellFolder;
    p: PItemIDList;
    chEaten: ULONG;
    dwAttributes: ULONG;
    DataObject: IDataObject;
    Effect: LongInt;
begin
  GetTempPath(SizeOf(TempDir),TempDir);
  with (Sender as TMemo) do
    begin
      if (csLButtonDown in ControlState) and ((Abs(X - FDragStartPos.x) >= Threshold) or (Abs(Y - FDragStartPos.y) >= Threshold)) then
        begin
          Perform(WM_LBUTTONUP, 0, MakeLong(X, Y));
          Memo.Lines.SaveToFile(TempDir+'즲.txt');
          DataObject:=nil;
          OleCheck(SHGetMalloc(Malloc));
          OleCheck(SHGetDesktopFolder(Root));
          OleCheck(Root.ParseDisplayName(0, nil, PWideChar(WideString(TempDir)), chEaten, FolderPidl, dwAttributes));
          try
            OleCheck(Root.BindToObject(FolderPidl, nil, IShellFolder, Pointer(Folder)));
            OleCheck(Folder.ParseDisplayName(0, nil, PWideChar(WideString('즲.txt')), chEaten, p, dwAttributes));
            OleCheck(Folder.GetUIObjectOf(0, 1, p, IDataObject, nil, Pointer(DataObject)));
          finally
            Malloc.Free(p);
            Malloc.Free(FolderPidl);
          end;
          Effect:=DROPEFFECT_NONE;
          DoDragDrop(DataObject, Self, DROPEFFECT_MOVE, Effect);
        end;
    end;
end;

initialization
  OleInitialize(nil);
finalization
  OleUninitialize;
end.
